%%% Trekker ut IVR og IVC fra akselerometerdataen ved hjelp av
%%% IVC:    Start i bunnpunkt rett fr den kraftigste stigningen
%%%         Slutt n?r LV > ABP
%%% IVR:    Start i globalt minimum av dP/dt for hvert hjertesalg
%%%         Pga problem med ? bestemme stopp er dette satt 22 sampler / 44 ms etter
%%%
%%% Kjr lesInnData.m fr du kjrer dette scriptet
%%%
%%% OBS! Lukker alle plot du m?tte ha oppe OBS!
function [ivc ivr] = trekkUtIvrc(trykk, beatStart,beatStopp, fs)

lv = trykk.lv;
abp = trykk.abp;

derivert = diff(lv);

%Finne startpunkt IVR = min (derivert) for hvert hjerteslag

ivr = [];
ivc = [];
avstand_fra_start_til_slutt_IVR = round(0.075*fs); %(ivr slutter 75 ms etter)
for i = 1:length(beatStart)
    if( i == length(beatStart) )
        %disp('i == length(beatStart))')
        disp('Ferdig med utregning av IVR og IVC')
    else
        % Finner hvor ivr begynner (ivr slutter 75 ms etter)
  
            
        [ verdi plass ] = min( derivert( beatStart(i):beatStopp(i) ) );
        ivr = [ivr ; ( beatStart(i) + plass ) ( beatStart(i) + plass + avstand_fra_start_til_slutt_IVR )];
    
        
        
        %Finner hvor ivc slutter
        plassering_hvor_trykk_ventrikkel_er_storre_enn_aorta = 0; %Denne brukes for  finne ivcStopp
        for j = beatStart(i):beatStopp(i)
            if lv(j) > abp(j)
                %ivcStopp(j) = 3;
                plassering_hvor_trykk_ventrikkel_er_storre_enn_aorta=j;
                break;
            end
        end
        % temp = find(lv(beatStart(i) : beatStopp(i)) > abp(beatStart(i) : beatStopp(i)));
        % plassering_hvor_trykk_ventrikkel_er_storre_enn_aorta = temp(1);
        
        %Finner hvor ivc begynner
        if ( plassering_hvor_trykk_ventrikkel_er_storre_enn_aorta == 0 ) 
            disp(['Feil p trykkdata, setter ivc til [1 1], hjerteslag nummer ' num2str(i)])
            ivc = [ivc; 1 1 ];
        else
            skift = round(0.05*fs);
            ivcStart_sampleverdi = plassering_hvor_trykk_ventrikkel_er_storre_enn_aorta - skift;
            if( ivcStart_sampleverdi < 1 )
                ivc = [ivc; 1 plassering_hvor_trykk_ventrikkel_er_storre_enn_aorta ];                
            else
                ivc = [ivc; ivcStart_sampleverdi plassering_hvor_trykk_ventrikkel_er_storre_enn_aorta ];
            end
        end
    end
    
end
