% Leser inn alle grisene og legger dem i en fin rekke som Mette liker

metoder = {'areal';
'delta';
'fart';
'effekt';
'bevegelse';
'vinkel';
'korrelasjon';
};

antall_metoder = size(metoder);
antall_metoder = antall_metoder(1);

y = [];
X = [];
metodeListe = {};

for i = 1:antall_metoder
    struktur_metode = les_inn_data_fra_metode([ metoder{i,:} '.mat'] );

    svar = sorter_som_Mette_vil_ha_det(struktur_metode, metoder{i,:});

    y = [y; svar.forhold];
    X = [X; svar.gris ones(size(svar.gris))*i];
    
    metodeListe = [metodeListe; svar.metodeListe];
    
    mette_matrise = [y,X];

end

metodeListe = char(metodeListe);

%% Regress-celle

Y = y - mean(y(1:15)); %log eller ikke

[b,BINT,R,RINT,STATS] = regress( Y ,[ ones( size(y) ) X  ]);
%[b,BINT,R,RINT,STATS] = regress(log(y),[ ones( size(y) ) X(:,2) ]);


scatter3(X(:,1),X(:,2), Y ,'filled')
hold on
x1fit = min( X(:,1) ): 1 :max( X(:,1) );
x2fit = min( X(:,2) ): 1 :max( X(:,2) );
[X1FIT,X2FIT] = meshgrid(x1fit,x2fit);
YFIT = b(1) + b(2)*X1FIT + b(3)*X2FIT %+ b(4)*X1FIT.*X2FIT;
%YFIT = b(1) + b(2)*X2FIT;% + b(3)*X2FIT + b(4)*X1FIT.*X2FIT;
 
mesh(X1FIT,X2FIT,YFIT)
%mesh(X2FIT,YFIT)

xlabel('Gris')
ylabel('Metode')
zlabel('Utslag')
%view(50,10)
colorbar

%% Boxplot

figure
set(gca,'fontsize',14)
boxplot( ( ( log(y) ) ), metodeListe, 'grouporder',metoder)
ylabel('Forholdstall')
title('Okklusjoner')