function RxMatrix = FinnQRboelgen(wfm,figurnr)
% Denne filen finner R og Q blge toppen. Den bruker wfm.trace(2,:) og
% wfm.samplerate. Den kan ogs ha en figurnr variabel som forteller om den
% skal vise figurer av ECG signalet og R og Q punktene som ble funnet. Hvis
% figurnr er 0 eller ingenting, vil ingen figur bli vist. Hvis figurnr
% inneholder et tall vil grafen bli vist.
% Returnerer en array som inneholder punktene relativt til wfm.trace vektoren.
% 
% RxMatrix = FinnQRboelgen(wfm,10);

orgECG   = wfm.trace(2,:);
start = 1;
slutt = length(orgECG);
x = (start:1:slutt);
if nargin==2 & figurnr~=0
    hvfig=figure; plot(x,orgECG(start:slutt)); hold on;
end;

% Hypassfiltrere ECG signalet
[b,a] = cheby2(6,50,5/(wfm.samplerate/2),'high'); % Hypass filtrerer
%[b,a] = cheby2(4,50,[5/(wfm.samplerate/2) 40/(wfm.samplerate/2)]);
ECG   = filtfilt(b,a,orgECG);

if nargin==2 & figurnr~=0
    figure(hvfig); plot(x,ECG(start:slutt),'g');
end;


%---------------------------------------------------------------
%===================== Finne frste Q og R =====================
maksp=-10000; minp=10000;
% Leteomrdet etter R er avhengig av leteomrdet etter Q
for i=start+(wfm.samplerate/25)+1:start+(wfm.samplerate/25)+1+wfm.samplerate
    % Finne det hyeste toppunktet AV de frste samplene
    if maksp<ECG(i) & ECG(i)>=ECG(i-1) & ECG(i)>=ECG(i+1) & ECG(i)>=ECG(i-2) & ECG(i)>=ECG(i+2)
        maksp=ECG(i);  % Temp variabel som inneholder toppunkt amplituden
        makspnr=i;     % Temp variabel som inneholder x-akse posisjon
    end;
end;
ok=0; i=makspnr;
while not(ok)
    % Finne det frste bunnpunktet til venstre for toppunktet innen 40 sampler
    if minp>ECG(i) & ECG(i)<=ECG(i-1) & ECG(i)<=ECG(i+1) & ECG(i)<=ECG(i-2) & ECG(i)<=ECG(i+2)
        minp=ECG(i);
        minpnr=i;
        ok=1;
    end;
    if i<(makspnr-(wfm.samplerate/20))
        figure;plot(ECG); 
        error('Finner ingen Q eller R!');
    else
        i=i-1;
    end;
end;
if maksp~=-10000 & minp~=10000
    Q  = minp;
    Qx = minpnr;
    R  = maksp;
    Rx = makspnr;
    if nargin==2 & figurnr~=0
       plot(makspnr,orgECG(makspnr),'ro');
       plot(minpnr,orgECG(minpnr),'ro');
    end;
else
    figure;plot(ECG); 
    error('Feil med Q eller R!!');
end;
%===================== Finne NESTE Q og R =====================

maksp=-10000; minp=10000;
i=Rx+50; ok=0;
while not(ok)
    % Finne det frste toppunktet i de frste 250 samplene
    if R-(R/3)<ECG(i) & ECG(i)>=ECG(i-1) & ECG(i)>=ECG(i+1) & ECG(i)>=ECG(i-2) & ECG(i)>=ECG(i+2)
        maksp=ECG(i);       % Temp variabel som inneholder toppunkt amplituden
        makspnr=i;          % Temp variabel som inneholder x-akse posisjon
        ok=1;
    else
        if i==Rx+50+wfm.samplerate
            figure;plot(ECG); 
            error('Finner ingen R!');
        end;
        i=i+1;
    end;
end;
ok=0; i=makspnr;
while not(ok)
    % Finne det frste bunnpunktet til venstre for toppunktet innen 10 sampler
    if minp>ECG(i) & ECG(i)<=ECG(i-1) & ECG(i)<=ECG(i+1) & ECG(i)<=ECG(i-2) & ECG(i)<=ECG(i+2)
        minp=ECG(i);
        minpnr=i;
        ok=1;
    end;
    if i<(makspnr-(wfm.samplerate/20))
        figure;plot(ECG); 
        error('Finner ingen Q eller R!!!');
    else
        i=i-1;
    end;
end;
if maksp~=-10000 & minp~=10000
    % n str for neste
    nQ  = minp;
    nQx = minpnr;
    nR  = maksp;
    nRx = makspnr;
    if nargin==2 & figurnr~=0
        plot(makspnr,orgECG(makspnr),'ro');
        plot(minpnr,orgECG(minpnr),'ro');
    end;
else
    figure;plot(ECG); 
    error('Feil med Q eller R!!');
end;
% Oppretter gjennomsnittsverdier
gjRhoyde      = (R+nR)/2;
gjQRhoyde     = ((R-Q)+(nR-nQ))/2;
gjQRavstand   = ((Rx-Qx)+(nRx-nQx))/2;
gjbolgelengde = nRx-Rx;
% Lagre R
Rxteller = 1;
RxArray(Rxteller) = Rx;
RxMatrix = [Rx ; nRx]; % NY RxArray Matrise over hjertesyklene
QxArray(Rxteller) = Rx-Qx;
% Oppdatere R og Q
R  = nR;
Rx = nRx;
Q  = nQ;
Qx = nQx;

% Start varialbler
gyldighjslag = 0; slutten = 0; haddeproblemer = 0;
while not(slutten)
    % --------------------------------------------------------------
    % --------------------- Finne neste R og Q ---------------------
    % --------------------------------------------------------------
    % Finne den hyeste toppen rundt blgelengden
    hoyestenRf = 100000;
    hoyestenRxf = Rx+10000000; % hyeste neste R x nvrende
    okR = 0; sjanser = 1;
    while not(okR) & sjanser<10
        hoyestenRn=-10000;
        % Sker rundt gjenomsnittlig blgelengde
        for j=Rx+round(gjbolgelengde-gjbolgelengde/2.8):Rx+round(gjbolgelengde+gjbolgelengde/3)
            if ECG(j)>=hoyestenRn ...                   % Er nvrende ECG strre enn eller lik hittil strste nvrende ECG
                    & (ECG(j)<hoyestenRf ...            % OG (Er nvrende ECG mindre enn den forigje strste
                    | (ECG(j)==hoyestenRf ...           % ELLER er ECG like stor som siste
                    & j<hoyestenRxf)) ...               % OG er nvrende posisjonen fr den siste hyeste toppen)
                    & ECG(j)>=ECG(j+1) & ECG(j)>=ECG(j-1)... % OG er det et toppunkt? Er punktet til hyre eller venstre mindre?
                    & ECG(j)>=ECG(j+2) & ECG(j)>=ECG(j-2) % OG er det et videre toppunkt?
                % Har ett hyt punkt men vet ikke om det er det hyeste
                % Oppdaterer hyeste verdi.
                hoyestenRn  = ECG(j);
                hoyestenRxn = j;
                % hoyestenRn < hoyestenRxf
            end;
        end;
        % Har ett toppunkt som kansje passer
        % Oppdatere 
        hoyestenRf  = hoyestenRn;
        hoyestenRxf = hoyestenRxn;
        % Finne det frste bunnpunktet til venstre for toppunktet
        i   = hoyestenRxn-1;
        okQ = 0;
        while not(okQ) & i>(hoyestenRxn-gjQRavstand*2)
            if ECG(i)<ECG(i-1) & ECG(i)<ECG(i-2) ...                      % Er nvrende ECG(i) mindre enn ECG til venstre, ECG(i-1)
                    & ECG(i)<ECG(i+1) & ECG(i)<ECG(i+2) ...               % Er nvrende ECG(i) mindre enn ECG til venstre, ECG(i-1)
                    & ECG(hoyestenRxn)-ECG(i)>(gjQRhoyde-gjQRhoyde/2) ... % OG passer Q-R hyden med gjennomsnittet: Hyere 
                    & ECG(hoyestenRxn)-ECG(i)<(gjQRhoyde+gjQRhoyde/2)     % OG lavere
                % ECG(i) er ett bunnpunkt som passer toppunktet ECG(j)
                % Oppdaterer nR, nRx, nQ, nQx
                okQ = 1;
                okR = 1;
                nR   = hoyestenRn;
                nRx  = hoyestenRxn;
                nQ   = ECG(i);
                nQx  = i;
                gyldighjslag = 1;
                sjanser = 1;
                break;
            else
                i = i-1;
            end;
        end;
        % Oppdatere hvor mange sjanser programmet har brukt p  finne en R som passer.
        sjanser = sjanser + 1;
    end;
    
    % Hvis sjansene ikke er brukt opp
    if gyldighjslag
        % Har funnet en R og en Q som er brukbar
        % Oppdatere gjennomsnittsverdiene
        gjRhoyde      = (gjRhoyde*10+nR)/11;
        gjQRhoyde     = (gjQRhoyde*10+nR-nQ)/11;
        gjQRavstand   = (gjQRavstand*10+nRx-nQx)/11;
        gjbolgelengde = (gjbolgelengde*10+nRx-Rx)/11;
        % Lagre R og Q 
        if haddeproblemer
            haddeproblemer = 0;
        else
            Rxteller = Rxteller+1;
            RxArray(Rxteller,:) = Rx;
            RxMatrix(:,Rxteller) = [Rx ; nRx];
            QxArray(Rxteller) = Rx-Qx;
        end;
        % Oppdatere R og Q
        R  = nR;
        Rx = nRx;
        Q  = nQ;
        Qx = nQx;
        % Plotter R og Q p grafen
        if nargin==2 & figurnr~=0
            plot(nQx,orgECG(nQx),'rx');
            plot(nRx,orgECG(nRx),'rx');
        end;
        gyldighjslag = 0;
    elseif sjanser<=10
        % Har brukt opp alle sjansene p  finne en brukbar R og Q, 
        % hopper over en gjennomsnittelig blgelengde og prver p nytt der.
        fprintf('\nSjansene var brukt opp. Prver p nytt litt lenger fram.');
        fprintf('Rx: %d',Rx); 
        Rx  = round(Rx+gjbolgelengde);
        Qx  = round(Qx+gjbolgelengde);
        fprintf('Neste Rx: %d \n',Rx);
        haddeproblemer = 1; % Denne variabelen retter opp RxMatrisen.
        % Siden algoritmen ikke ordner med intervaler der QR blgen ikke blir funnet
        % m algoritmen da avsluttes:
        %error('Kan ikke fortsette fordi QR blgen ikke ble funnet.');
    end;

    % Tester om slutten er nr
    if (Rx+round(gjbolgelengde+gjbolgelengde/3))>slutt
        slutten = 1;
    end;
end;

% % Justere R-topp verdiene til  passe til topppunktene p det egentlige EKG signalet
for i=1:length(RxMatrix(1,:))
    for j=RxMatrix(1,i)-3*(wfm.samplerate/250):RxMatrix(1,i)+3*(wfm.samplerate/250)
        if wfm.trace(2,j)>=wfm.trace(2,j+1) & wfm.trace(2,j)>=wfm.trace(2,j-1)
            break;
        end;
    end;
    RxMatrix(1,i) = j;
    if nargin==2 & figurnr~=0
        plot(j,wfm.trace(2,j),'kx');
    end;
    for j=RxMatrix(2,i)-3*(wfm.samplerate/250):RxMatrix(2,i)+3*(wfm.samplerate/250)
        if wfm.trace(2,j)>=wfm.trace(2,j+1) & wfm.trace(2,j)>=wfm.trace(2,j-1)
            break;
        end;
    end;
    RxMatrix(2,i) = j;
    if nargin==2 & figurnr~=0
        plot(j,wfm.trace(2,j),'kx');
    end;
end;

for i=1:length(RxMatrix(1,:))
    RxMatrix(3,i)=wfm.samplerate/diff(RxMatrix(1:2,i),1,1);
end

fprintf('Antall hjertesykler: %d. ',length(RxMatrix(1,:)));
fprintf('Gjennomsnittelig hjertefrekvens: %3.1f BPM, ',(wfm.samplerate/mean(diff(RxMatrix(1,:)))*60));
fprintf('med standaravvik: %3.1f BPM\n',(wfm.samplerate/(mean(diff(RxMatrix(1,:)))-std(diff(RxMatrix(1,:))))*60)-(wfm.samplerate/mean(diff(RxMatrix(1,:)))*60));
