%%% Tar inn trykket i venstre ventrikkel (lv), og finner beaten ut fra det
%%% bruk: beat = finnBeatVHAtrykk(lv, fs, vil_du_ha_plassering);
%%%
%%% lv = trykk i venstre ventrikkel
%%% fs = samplingsfrekvens
%%%
%%% Metoden er tilpasset trykket i et grisehjerte
%%% vil_du_ha_plassering = 1
%%% Metoden returnerer sample-verdien til der hjerteslaget starter
%%%
%%% vil_du_ha_plassering = 0
%%% Metoden returneren beat med samme lengde som lv, med verdien 1 der
%%% hjerteslaget begynner, og verdien 0 ellers



function beat = finnBeatVHATrykk(lv, fs, vil_du_ha_plassering)

%lv = data.trykk.lv(50000:55000);
%fs = data.fs;

beat = zeros(1, length(lv));

for i = 1:length(lv)
    if lv(i) < 50
        lv(i) = 0;
    end
end

flytt_antall_sampler = round(0.2 * fs);

sampler_bak_topp = ceil(0.33*fs);
sampler_foran_topp = round(0.33 * fs);

[verdi plass ] = max( lv );
%lv(plass-sampler_bak_topp : plass+sampler_foran_topp) = 0;

disp('\nStarter while-lokka i finnBeatVHATrykk:')
tic
bruk_while = 0;
if(bruk_while == 1)
    while(verdi ~= 0)


         %lv rundt plass settes til 0
        if(plass > flytt_antall_sampler )
            beat( plass - flytt_antall_sampler ) = 1;
            lv(plass-sampler_bak_topp: round(plass+sampler_foran_topp)) = 0;
        else
            beat(1) = 1;
            disp('Noe gikk galt, hjerteslaget startet f?r ecgsignalet, men den eminente koden tar seg av problemet')
            lv(1:plass+sampler_foran_topp) = 0;    
        end
        % rince and repeat

        [verdi, plass] = max(lv);
    end

elseif(bruk_while == 0)
    hopplengde = round(fs/5);
    hvor_langt = (hopplengde * 2) -1 ;
    for i = 1: hopplengde :length(lv)
        %disp(i)
        if(length(lv) < i+hvor_langt )
            [verdi plass] = max( lv( i: end ) );
            plass = plass + i -1;            
        else
            [verdi plass] = max( lv( i: i+hvor_langt ) );
            plass = plass + i -1;
        end
        
        if(plass > flytt_antall_sampler && verdi > 0 )
            beat( plass - flytt_antall_sampler ) = 1;
            tall = plass-sampler_bak_topp;
            if(tall <= 0)
                tall = 1;
            end
            lv(tall: round(plass+sampler_foran_topp)) = 0;
        elseif(plass <= flytt_antall_sampler && verdi > 0 )
            beat(1) = 1;
            disp('Noe gikk galt, hjerteslaget startet f?r ecgsignalet, men den eminente koden tar seg av problemet')
            lv(1:plass+sampler_foran_topp) = 0;    
        end     
    end
end
toc

if (vil_du_ha_plassering == 1)
    beat = find(beat > 0);
end
%figure
%plot(lv)