% function lengde = omkrets2(data)

% Sletter brukte parametere
clear lengde midl

% Setter nye parametere
intervall = measdata.interval;
posx = data.posisjon.x;
posy = data.posisjon.y;
posz = data.posisjon.z;
beatplass = data.beatStart;
ivc = data.ivrc.ivc;
ivr = data.ivrc.ivr;

% Dersom kjorIvcIvr = 1 beregnes posisjonen til ivc, ved kjorIvcIvr = 2
% beregnes posisjonen til ivr og ellers beregnes posisjonen til hele slaget
kjorIvcIvr = 2;

lengde= [];
if(kjorIvcIvr == 1)
    for i = 1:length(beatplass)-1
        clear p
        p = sqrt(posx(ivc(i,1):ivc(i,2)).^2+posy(ivc(i,1):ivc(i,2)).^2+posz(ivc(i,1):ivc(i,2)).^2);
        lengde(i) = sum(p)/length(ivc(i,1):ivc(i,2));
        %     lengde = sqrt(posx.^2 + posy.^2 + posz.^2);
    end
elseif(kjorIvcIvr == 2)
    for i = 1:length(beatplass)-1
        clear p
        p = sqrt(posx(ivr(i,1):ivr(i,2)).^2+posy(ivr(i,1):ivr(i,2)).^2+posz(ivr(i,1):ivr(i,2)).^2);
        lengde(i) = sum(p)/length(ivr(i,1):ivr(i,2));
        %     lengde = sqrt(posx.^2 + posy.^2 + posz.^2);
    end
else
    for i = 1:length(beatplass)-1
        clear p
        p = sqrt(posx(beatplass(i):beatplass(i+1)-1).^2 + posy(beatplass(i):beatplass(i+1)-1).^2 + posz(beatplass(i):beatplass(i+1)-1).^2);
        lengde(i) = sum(p)/length(beatplass(i):beatplass(i+1)-1);
        %     lengde = sqrt(posx.^2 + posy.^2 + posz.^2);
    end
end

        
for i =1:length(lengde)-5
    midl(i) = sum(lengde(i)+lengde(i+1)+lengde(i+2)+lengde(i+3)+lengde(i+4))/5;%+lengde(i+5)+lengde(i+6)+lengde(i+7));
end
lengde = midl; 

%Plotter ut grafene
if(kjorIvcIvr == 1)
    t = linspace(intervall(1)-10,intervall(2)+10, length(lengde));
    set(gca,'fontsize',14)
    plot(t,lengde),xlabel('Tid i sekunder'),ylabel('Hjertetsbevegelse [m]'),title('Bevegelsen i IVC-perioden');ylim([0.002 0.02])
    grid minor
elseif(kjorIvcIvr == 2)
    t = linspace(intervall(1)-10,intervall(2)+10, length(lengde));
    set(gca,'fontsize',14)
    plot(t,lengde),xlabel('Tid i sekunder'),ylabel('Hjertetsbevegelse [m]'),title('Bevegelsen i IVR-perioden');ylim([0.002 0.02])
    grid minor
else
    t = linspace(intervall(1)-10,intervall(2)+10, length(lengde));
    set(gca,'fontsize',14)
    plot(t,lengde),xlabel('Tid i sekunder'),ylabel('Hjertetsbevegelse [m]'),title('Bevegelsen i for hvert hjerteslag');ylim([0.002 0.02])
    grid minor
end