% function pos = posisjon(data,intervall)

% Lukker vinduer og sletter tidligere parametere
clear t pos
close all

% Setter nye parametere
intervall  = measdata.interval;
beat = data.beatStart;
ivr = data.ivrc.ivr;
ivc = data.ivrc.ivc;
posx = data.posisjon.x';
posy = data.posisjon.y';
posz = data.posisjon.z';
aksely = data.akselerasjon.y';

% Velger parameteren som skal brukes fra de over
parameter_valgt = posy;

% Velger om jeg skal kjre IVR eller IVC, kjorIvr = 1 kjrer IVR.IVC ellers
kjorIvr = 1;

% Plukker ut avstanden hjertet beveger seg i en bestemt retning under en
% ivc eller ivr periode
if(kjorIvr == 1)
    for i=1:length(ivr)
        clear test
        test = sqrt( (parameter_valgt(ivr(i,1):ivr(i,2))).^2 );
        pos(i) = sum(test)/(ivr(i,2)-ivr(i,1));
       %pos(i) = parameter_valgt(ivr(i,2)) - parameter_valgt(ivr(i,1)); 
    end
else
    for i =1:length(ivc)
        clear test
        test = sqrt( (parameter_valgt(ivc(i,1):ivc(i,2))).^2 );
        pos(i) = sum(test)/(ivc(i,2)-ivc(i,1));
        %pos(i) = parameter_valgt(ivc(i,2)) - parameter_valgt(ivc(i,1));
    end
end

% Lager en midling for  f en smoothere signal
for i =1:length(pos)-5
    midl(i) = sum(pos(i)+pos(i+1)+pos(i+2)+pos(i+3)+pos(i+4))/5;%+pos(i+5)+pos(i+6)+pos(i+7));
end
pos = midl;

if(kjorIvr == 1)
    t = linspace(intervall(1) -10 , intervall(2) + 10, length(pos) );
    set(gca,'fontsize',14)
    plot(t,pos);grid minor, title('Hvor mye hjerte beveger seg i y-retning i lpet av IVR-perioden'),xlabel('Tid [s]'),ylabel('Bevegelse i [m]');
else
    t = linspace(intervall(1) -10 , intervall(2) + 10, length(pos) );
    set(gca,'fontsize',14)
    plot(t,pos);grid minor, title('Hvor mye hjerte beveger seg i y-retning i lpet av IVC-perioden'),xlabel('Tid [s]'),ylabel('Bevegelse i [m]');
end
