%%% Regner ut effekttettheten i signalene %%%
%%% effektspekter = gir ut den gjennomsnittlige verdien av effektspekteret over en periode

% f_sum = er den gjennomsnittlige effekttettheten for hver periode som blir beregnet
% data = dataen som kommer fra kjoerProgram.m
% tidsintervall = tidsintervallet som hrer til data fra kjoerProgram.m

% function f_sum = fourier(data,tidsintervall)
tidsintervall = measdata.interval;

%Sletter tidligere lagrede verdier
clear frekvens f_sum1 f_sum2 midl

% setter navn p en del parametere som blir brukt fra data
akselX = data.akselerasjon.x;
akselY = data.akselerasjon.y;
akselZ = data.akselerasjon.z;
posX = data.posisjon.x;
posY = data.posisjon.y;
posZ = data.posisjon.z;
beatStart = data.beatStart;
ivc = data.ivrc.ivc;
ivr = data.ivrc.ivr;

% Setter parameteren som nskes brukt av de overstende
parameter_brukt = posY;%sqrt(posX.^2 + posY.^2 + posZ.^2);

clear frekvens

% Regner ut frekvensen for hvert hjerteslag
for i = 1:length(beatStart)-1
   clear ffty
   trekk_ut = parameter_brukt(beatStart(i):beatStart(i+1)-1);
%        ffty = fft(trekk_ut);
%        f_sum(i) = sum(ffty.*conj(ffty)/( (ivr(i,2)-ivr(i,1))) / data.fs );

    [frek verdi] = cp0301_PSD(trekk_ut,data.fs);
    f_sum1(i) = verdi;
end

% Regner ut frekvensen for hver ivr-periode
for i = 1:length(ivr)
   clear ffty
   trekk_ut = parameter_brukt(ivr(i,1):ivr(i,2));
%        ffty = fft(trekk_ut);
%        f_sum(i) = sum(ffty.*conj(ffty)/( (ivr(i,2)-ivr(i,1))) / data.fs );

    [frek verdi summen] = cp0301_PSD(trekk_ut,data.fs);
    f_sum1(i) = verdi;
end

% Regner ut frekvensen for hver ivr-periode
for i = 1 :length(ivc)
   clear ffty
   trekk_ut = parameter_brukt(ivc(i,1):ivc(i,2));
   [frek verdi summen] = cp0301_PSD(trekk_ut,data.fs);
   f_sum2(i) = verdi;

       ffty = fft(trekk_ut);
       f_sum(i) = sum(ffty.*conj(ffty)/(beatStart(i+1)-beatStart(i)-1)); 
end


% Lager en midling som en filtreringsmetode for ivr
for i =1:length(f_sum1) - 8
        midl(i) = sum( f_sum1(i) + f_sum1(i+1) + f_sum1(i+2) + f_sum1(i+3) + f_sum1(i+4) + f_sum1(i+5) + f_sum1(i+6) + f_sum1(i+7)) / 8;
end
f_sum1 = midl;
clear midl

% t = linspace( tidsintervall(1)-10 , tidsintervall(2)+10 , length(f_sum1) );
% set(gca,'fontsize',14)
% plot(t,f_sum1), grid minor,xlabel('Tid [s]'),ylabel('Effekten'),title('Effekten i hvert hjerteslag lagret over tid');ylim([0 2e-4])
% Lager en midling som en filtreringsmetode for ivr
for i =1:length(f_sum2) - 8
        midl(i) = sum( f_sum2(i) + f_sum2(i+1) + f_sum2(i+2) + f_sum2(i+3) + f_sum2(i+4) + f_sum2(i+5) + f_sum2(i+6) + f_sum2(i+7)) / 8;
end
f_sum2 = midl;
% 
% % [B,A] = BUTTER(6,100/data.fs);
% % 
% % f_sum=filter(B,A,f_sum);
% 
% plotter effektspekteret
subplot(2,1,1)
    t = linspace( tidsintervall(1)-10 , tidsintervall(2)+10 , length(f_sum2) );
    set(gca,'fontsize',14)
    plot( t , f_sum2 );grid minor, xlabel('Tid [s]'),ylabel('Effekten'),title('Effekten i hver ivc-periode lagret over tid');%ylim([0 2e-5])
subplot(2,1,2)
    set(gca,'fontsize',14)
    t = linspace( tidsintervall(1)-10 , tidsintervall(2)+10 , length(f_sum1) );
    plot( t , f_sum1 );grid minor, xlabel('Tid [s]'),ylabel('Effekten'),title('Effekten i hver ivr-periode lagret over tid');%ylim([0 5e-5])
