%%% Metoden regner ut hvor korrelert et baselinesignal er i forhold til
%%% etterflende hjerteslag 

%%% data = dataen som kommer fra kjoerProgram.m
%%% tidsintervall = den tiden hrer til data fra kjoerProgram.m

function [] = autoKorr(data,tidsintervall)
% korrelasjonen korrelasjon1 korrelasjon2
% tidsintervall = measdata.interval;

% Nullstillere en del parametere som blir brukt
clear slag ref midl korrelasjon1 korrelasjon2

% setter navn p en del parametere som blir brukt fra data
akselX = data.akselerasjon.x;
akselY = data.akselerasjon.y;
akselZ = data.akselerasjon.z;
posX = data.posisjon.x;
posY = data.posisjon.y;
posZ = data.posisjon.z;
beatStart = data.beatStart;
ivc = data.ivrc.ivc;
ivr = data.ivrc.ivr;

% velger det den parametertypen som skal brukes i krysskorrelasjon
slag = posY';

% velger om vi skal bruke ivr-perioden, ivc-perioden eller et hjerteslag til  beregne korrelasjonen
bruk_ivr_ivc = 1;

% lager et baseline-signal ved bruk av x etterflgende hjerteslag i
% friskt-omrde. Frste input er signalet det skal lages baseline-signal
% av, input 2 er x antall hjerteslag etterflgende treningssekvensen skal 
% lages av, input 3 er beatStarten, input 4 er ivc og ivr-periodene
ref1 = trainingseq( slag , 10 , beatStart , ivc , bruk_ivr_ivc , 10);
ref2 = trainingseq( slag , 10 , beatStart , ivr , bruk_ivr_ivc, 10 );
% gjr krysskorrelasjonen mellom treningssekvensen og de etterflgende slagene
if(bruk_ivr_ivc == 1)
    for i = 2:length(ivr)-1
        clear e_slag c
        e_slag = slag(ivr(i,1):ivr(i,2));
        c = xcorr(ref2,e_slag);
        c = abs(c);
        [verdi plass] = max(abs(c));
        if (plass > 60)
            plass = 38;
            verdi = c(plass);
        end
        test = c(plass+1)/verdi;
        if(test >=1) 
            test = 0.96;
        end
        korrelasjon1(i-1) = test;
    
        clear e_slag c
        e_slag = slag(ivc(i,1):ivc(i,2));
  
        c = xcorr(e_slag,ref1);
        c = abs(c);
        [verdi plass] = max(abs(c));
        if (plass > 50)
            plass = 26;
            verdi = c(plass);
        end
        test = c(plass+1)/verdi;
        if(test >=1) 
            test = 0.96;
        end
        korrelasjon2(i-1) = test;
    end
else
    for i = 2:length(beatStart)-1
        clear e_slag c
        e_slag = slag(beatStart(i):beatStart(i+1)-1);
        c = xcorr(ref1,e_slag);
        [verdi plass] = max(c);
        korrelasjonen(i-1) = c(plass+15)/verdi;
    end
end

% filtrerer korrelasjonen s vi fr et smoothere signal
if( bruk_ivr_ivc == 1)
    for i =1:length(korrelasjon1)-8
            midl(i) = sum(korrelasjon1(i)+korrelasjon1(i+1)+korrelasjon1(i+2)+korrelasjon1(i+3)+korrelasjon1(i+4)+korrelasjon1(i+5)+korrelasjon1(i+6)+korrelasjon1(i+7))/8;
    end
    korrelasjon1 = midl;

    for i =1:length(korrelasjon2)-8
            midl(i) = sum(korrelasjon2(i)+korrelasjon2(i+1)+korrelasjon2(i+2)+korrelasjon2(i+3)+korrelasjon2(i+4)+korrelasjon2(i+5)+korrelasjon2(i+6)+korrelasjon2(i+7))/8;
    end
    korrelasjon2 = midl;



    % lager plot
    t2=linspace(tidsintervall(1)-10,tidsintervall(2)+10,length(korrelasjon2));
    t1=linspace(tidsintervall(1)-10,tidsintervall(2)+10,length(korrelasjon1));
    subplot(2,1,1)
        set(gca,'fontsize',14)
        plot(t2,korrelasjon2), title('Korrelasjon mellom treningssekvens (baseline) og LAD-signal i IVC'),xlabel('Tid');grid minor;%ylim([0.94 1.00]); 
    subplot(2,1,2)
        set(gca,'fontsize',14)
        plot(t1,korrelasjon1), title(['Snittet er ' num2str(mean(korrelasjon1))]);%title('Korrelasjon mellom treningssekvens (baseline) og LAD-signal i IVR'),xlabel('Tid');grid minor ;%ylim([0.94 1.00]);
else
    for i =1:length(korrelasjonen)-8
            midl(i) = sum(korrelasjonen(i)+korrelasjonen(i+1)+korrelasjonen(i+2)+korrelasjonen(i+3)+korrelasjonen(i+4)+korrelasjonen(i+5)+korrelasjonen(i+6)+korrelasjonen(i+7))/8;
    end
    korrelasjonen = midl;
    
    t = linspace(tidsintervall(1)-10,tidsintervall(2)+10,length(korrelasjonen));
    set(gca,'fontsize',14)
    plot(t,korrelasjonen),grid minor,title('Korrelasjon mellom treningssekvens (baseline) og LAD-signal for hjerteslaget'),xlabel('Tid');ylim([0.94 1.00]);
    set(gca,'fontsize',14)
end
    
  