%%% Metoden lager en treningsseksvens av input-dataen som er et snitt av x antall
%%% etterflgende hjerteslag. 

% data = dataen som det skal lages baseline-signal av
% antPuls = antall etterflgende hjerteslag
% beatStart = begynnelsen p hvert enkelt hjerteslag
% ivr = dersom treningssekvensen skal lages av ivr-periodene
% velg_ivr = 1 dersom den skal benyttes, 0 ellers

function trening = trainingseq(data, antPuls,beatStart, ivr, velg_ivr, start)

b=0;
if(velg_ivr == 1)
    %finner det den hjertesekvensen med lengst ivr-periode, der b settes til
    %den lengste ivr-perioden
    for i =start:start+antPuls
        a = ivr(i,2)-ivr(i,1);
        if a>b
            b=a;
        end
    end

    % lager en sekvens med nullere etter hvor lang lengste ivr-periode er
    seq = zeros(antPuls,b);
    for i = start:start+antPuls
        mid = data(ivr(i,1):ivr(i,2));
        if ivr(i,2) - ivr(i,1) <b
            mid = [mid zeros(1,b - ivr(i,2) - ivr(i,1))];
        end
        seq(i,1:b+1) = mid;

    end
else
    % finner det hjerteslaget som varer lengst og lagrer antall sampler p
    % den i b.
    for i =start:start+antPuls
        a = length(beatStart(i):beatStart(i+1)-1);
        if a>b
            b=a;
        end
    end
    
    % lager en sekvens med nullere etter hvor lang lengste hjerteslag er
    seq = zeros(antPuls,b);
    for i = 2:2+antPuls
        mid = data(beatStart(i):beatStart(i+1)-1);
        if length(mid)<b
            mid = [mid zeros(1,b-length(mid))];
        end
        seq(i,1:b) = mid;

    end
    
end

% beregner gjennomsnittslaget ut fra de x-antall slagene som er brukt for 
% finne baseline-signalet
seeq = sum(seq,1)/antPuls;
trening = seeq;