% User interface functions
    function varargout = PlotMicroheartGUI(varargin)   % Graphical User interface 
    function PlotMicroheartBatch                       % Batch operation

    % Basic function        
        function PlotMicroheart(measdata)              % Main program
        % Calling
            function [sample,wfm,par]=InterpretTRC(sourcefile)  % Interpret data files
            function scaled= Trace2Acc(wfmr)                    % Scale accelerometer results 
            function PlotMHTraces(sample,measdata,scaled);      % Plot result

% Utility functions                
function trace= BuildTrace(t0,dt,y);           % Build waveform trace
function h=PlotWaveform(trace,method,varargin) % Plot waveform trace
function y=MHintegrate(x,fs,fc,N)              % Numerical intrgration with high pass filter
function cal=ReadCalibration(sensor)           % Read and interpret sensor calibration data