function y=MHintegrate(x,fs,fc,N)
% function y=MHintegrate(x,fs,fc,N)
%
% Integrate Microheart motion curves
% Remove respiration motion by high-pass filtering
%

% Lars Hoff, HVE, 2004 

%--- Default parameter settings ---
if nargin<3, N =0;   end  %      Number of intrgrations
if nargin<2, fc=1.0; end  % [Hz] Cut-off frequency to remove DC and respiration

%-- Filter and integrate ---
y = RemoveRespiration(x,fs,fc);       % Remove respiration by high-pass filtering
for k=1:N
    y = cumtrapz(y)*1/fs;            % Trapezoidal integration
    y = RemoveRespiration(y,fs,fc);
end

return


