%function PlotMicroheartBatch
% function PlotMicroheartBatch
%
% Plot measurements from 'PlotMicroheart'

measdata.AP        = 'AP116';   % Experiment 'AP116'
measdata.recording = 1;         % Recording no. 1
measdata.systemid  = 'B';       % System 'B'
measdata.respfilter= -1;        % Automatic respiration filter
measdata.ECGdelay  = 21.5;      % Delay in Siemens patient monitor
measdata.interval  = [291 296]; % Interval to plot [s]

measdata.Ncurves   = 3;         % Plot 3 curves 

mtypes= {'Acceleration', 'Velocity', 'Position'};
maxes = {'x', 'y', 'z'};
for m=1:3
    measdata.figno = m;
    for k=1:measdata.Ncurves    
        measdata.curve(k).type   = mtypes{m};   % Cycle over types
        measdata.curve(k).sensor = 'B';         % Sensor 'B'  in all plots
        measdata.curve(k).ax     = maxes{k};    % Cycle over axes
        measdata.curve(k).invert = 1;           % Invert 'on'
    end
    PlotMicroheart(measdata);
end

%return


