function varargout = PlotMicroheartGUI(varargin)
% PLOTMICROHEARTGUI M-file for PlotMicroheartGUI.fig
%      PLOTMICROHEARTGUI, by itself, creates a new PLOTMICROHEARTGUI or raises the existing
%      singleton*.
%
%      H = PLOTMICROHEARTGUI returns the handle to a new PLOTMICROHEARTGUI or the handle to
%      the existing singleton*.
%
%      PLOTMICROHEARTGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PLOTMICROHEARTGUI.M with the given input arguments.
%
%      PLOTMICROHEARTGUI('Property','Value',...) creates a new PLOTMICROHEARTGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before PlotMicroheartGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to PlotMicroheartGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help PlotMicroheartGUI

% Last Modified by GUIDE v2.5 01-Feb-2007 16:47:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @PlotMicroheartGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @PlotMicroheartGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before PlotMicroheartGUI is made visible.
function PlotMicroheartGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to PlotMicroheartGUI (see VARARGIN)

% Choose default command line output for PlotMicroheartGUI
handles.output = hObject;

%--- Read initial values from GUI ---
handles.MHdata.AP         = ReadPopup(handles.popupmenu_AP,0);
handles.MHdata.recording  = ReadPopup(handles.popupmenu_recording,1);
handles.MHdata.systemid   = ReadPopup(handles.popupmenu_systemid,0);
handles.MHdata.figno      = ReadPopup(handles.popupmenu_figno,1);

val = get(handles.edit_respfilter,'String'); handles.MHdata.respfilter= sscanf(val, '%f', 1);
val = get(handles.edit_ECGdelay,  'String'); handles.MHdata.ECGdelay  = sscanf(val, '%f', 1);
val = get(handles.edit_interval,  'String'); handles.MHdata.interval  = sscanf(val, '%f', 2);

handles.MHdata.Ncurves = 3;
for k=1:handles.MHdata.Ncurves
    %sprintf('handles.popupmenu_S_%d', k)
    hobj = eval(sprintf('handles.popupmenu_S%d', k));
    handles.MHdata.curve(k).sensor  = ReadPopup(hobj,0);

    hobj = eval(sprintf('handles.edit_ax%d', k));
    val= get(hobj,'String');
    handles.MHdata.curve(k).ax  = sscanf(val, '%f', 3);

    hobj = eval(sprintf('handles.popupmenu_type%d', k));
    handles.MHdata.curve(k).type  = ReadPopup(hobj,0);    
end

%--- Display logo image ---
imagefile     = 'SensorOrientation.png';  % Load iand interpret image file
handles.image = imread(imagefile ); 
iminfo        = imfinfo(imagefile ); 
ScaleImage(handles.Sensor_orientation,handles.image,iminfo,0)

%--- Display sensor image ---
imagefile     = 'PlotMicroheartHeader.png';  % Load iand interpret image file
handles.image = imread(imagefile ); 
iminfo        = imfinfo(imagefile ); 
ScaleImage(handles.logo,handles.image,iminfo,0)

guidata(hObject, handles);
% UIWAIT makes PlotMicroheartGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = PlotMicroheartGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
return


%=== PROGRAM SPECIFIC FUNCTIONS. Dec 2004, LH =======================

%=== POPUPMENU_AP =========================================
function popupmenu_AP_Callback(hObject, eventdata, handles)
handles.MHdata.AP=ReadPopup(hObject,0);
guidata(hObject,handles);
return

function popupmenu_AP_CreateFcn(hObject, eventdata, handles)
popupmenu_AP_Callback(hObject, eventdata, handles)
return

%=== POPUPMENU_RECORDING ==================================
function popupmenu_Recording_Callback(hObject, eventdata, handles)
handles.MHdata.recording=ReadPopup(hObject,1);
guidata(hObject,handles);
return

function popupmenu_Recording_CreateFcn(hObject, eventdata, handles)
popupmenu_Recording_Callback(hObject, eventdata, handles)
return

% --- Executes on selection change in popupmenu_SystemID.
function popupmenu_SystemID_Callback(hObject, eventdata, handles)
handles.MHdata.systemid=ReadPopup(hObject,0);
guidata(hObject,handles);
return

function popupmenu_SystemID_CreateFcn(hObject, eventdata, handles)
popupmenu_SystemID_Callback(hObject, eventdata, handles)
return


%=== EDIT_RESPFILTER ==================================
function edit_Respfilter_Callback(hObject, eventdata, handles)
val = get(hObject,'String');
handles.MHdata.respfilter = sscanf(val, '%f', 1);
guidata(hObject,handles);
return

% --- Executes during object creation, after setting all properties.
function edit_Respfilter_CreateFcn(hObject, eventdata, handles)
edit_Respfilter_Callback(hObject, eventdata, handles)
return


%=== EDIT_ECGDELAY  ==============================================
function edit_ECGdelay_Callback(hObject, eventdata, handles)
val = get(hObject,'String');
handles.MHdata.ECGdelay = sscanf(val, '%f', 1);
guidata(hObject,handles);
return

% --- Executes during object creation, after setting all properties.
function edit_ECGdelay_CreateFcn(hObject, eventdata, handles)
edit_ECGdelay_Callback(hObject, eventdata, handles)
return

%=== EDIT_INTERVAL ==============================================
function edit_Interval_Callback(hObject, eventdata, handles)
val = get(hObject,'String');
handles.MHdata.interval = sscanf(val, '%f', 2);
guidata(hObject,handles);
if isfield(handles.MHdata,'figno')      % Check that figure has been created
    if any(findobj(0) == handles.MHdata.figno)
        axes=get(handles.MHdata.figno,'children');
        for k=1:length(axes)
            set(axes(k),'xlim', handles.MHdata.interval)
        end
    end
end
return

function edit_Interval_CreateFcn(hObject, eventdata, handles)
edit_Interval_Callback(hObject, eventdata, handles)
return


%=== PUSHBUTTON_GETLIMITS ==================================
function pushbutton_getlimits_Callback(hObject, eventdata, handles)
alignmin=1;
tlim= set_tlim(handles,alignmin);
hint= findobj('Tag','edit_interval');
set(hint,'string',sprintf('%3.1f %3.1f',tlim));
edit_Interval_Callback(hint, eventdata, handles);
return

%=== POPUPMENU_S ==================================
function popupmenu_S_Callback(hObject, eventdata, handles)
str= get(hObject,'tag');
n  = sscanf(str,'popupmenu_S%d');
handles.MHdata.curve(n).sensor  = ReadPopup(hObject,0);
guidata(hObject,handles);
return

function popupmenu_S_CreateFcn(hObject, eventdata, handles)
popupmenu_S_Callback(hObject, eventdata, handles)
return


%=== EDIT_AX ==================================
function edit_ax_Callback(hObject, eventdata, handles)
str= get(hObject,'tag');
n  = sscanf(str,'edit_ax%d');
val= get(hObject,'String');
handles.MHdata.curve(n).ax  = sscanf(val, '%f', 3);
guidata(hObject,handles);
return

function edit_ax_CreateFcn(hObject, eventdata, handles)
edit_ax_Callback(hObject, eventdata, handles)
return


%=== POPUPMENU_TYPE ==================================
function popupmenu_type_Callback(hObject, eventdata, handles)
str= get(hObject,'tag');
n  = sscanf(str,'popupmenu_type%d');
handles.MHdata.curve(n).type  = ReadPopup(hObject,0);
guidata(hObject,handles);
return

function popupmenu_type_CreateFcn(hObject, eventdata, handles)
popupmenu_type_Callback(hObject, eventdata, handles)
return

%=== PUSHBUTTON_CALCULATE =================================
function pushbutton_Calculate_Callback(hObject, eventdata, handles)
[sample,wfmr,scaled]= PlotMicroheart(handles.MHdata);
return

%=== PUSHBUTTON_GRID =================================
function grid_Callback(hObject, eventdata, handles)
if any(findobj(0) == handles.MHdata.figno)
    child=get(handles.MHdata.figno,'children');
    n=0;
    for k=1:length(child)
        if strcmpi(get(child(k),'type'),'axes')
            n=n+1;
            haxes(n)= child(k);
        end
    end    
    for k=1:length(haxes)
        grid(haxes(k))
    end    
end
return

%=== PUSHBUTTON_ALIGN_T_AXES =================================
function pushbutton_alignt(hObject, eventdata, handles,alignmin)
if any(findobj(0) == handles.MHdata.figno)
    child=get(handles.MHdata.figno,'children');
    n=0;
    for k=1:length(child)
        if strcmpi(get(child(k),'type'),'axes')
            n=n+1;
            haxes(n)= child(k);
        end
    end
    for k=1:length(haxes)            
        ax(k,1:2)= get(haxes(k),'xlim');
    end
    if alignmin
        tlim(1)= max(ax(:,1));
        tlim(2)= min(ax(:,2));
    else
        tlim(1)= min(ax(:,1));
        tlim(2)= max(ax(:,2));
    end
    for k=1:length(haxes)        
        set(haxes(k), 'xlim', tlim);
    end    
end
return

function tlim=set_tlim(handles,alignmin);
if any(findobj(0) == handles.MHdata.figno)
    child=get(handles.MHdata.figno,'children');
    n=0;
    for k=1:length(child)
        if strcmpi(get(child(k),'type'),'axes')
            n=n+1;
            haxes(n)= child(k);
        end
    end
    for k=1:length(haxes)            
        ax(k,1:2)= get(haxes(k),'xlim');
    end
    if alignmin
        tlim(1)= max(ax(:,1));
        tlim(2)= min(ax(:,2));
    else
        tlim(1)= min(ax(:,1));
        tlim(2)= max(ax(:,2));
    end
    for k=1:length(haxes)        
        set(haxes(k), 'xlim', tlim);
    end    
end
return

% --- Executes on button press in pushbutton_alignt_min.
function pushbutton_alignt_min_Callback(hObject, eventdata, handles)
alignmin = 1;
set_tlim(handles, alignmin);
return

function pushbutton_alignt_max_Callback(hObject, eventdata, handles)
alignmin = 0;
set_tlim(handles, alignmin);
return

%=== CHECKBOX_ZOOM=====================================
% --- Executes on button press in checkbox_zoom_t.
function checkbox_zoom_t_Callback(hObject, eventdata, handles)
if any(findobj(0) == handles.MHdata.figno)
    figno= handles.MHdata.figno;
    zoom_on = get(hObject,'value');
    if zoom_on
        zoom(figno,'xon')
    else
        zoom(figno,'xoff')
    end
end
return

% --- Executes on button press in checkbox_zoom_y.
function checkbox_zoom_y_Callback(hObject, eventdata, handles)
if any(findobj(0) == handles.MHdata.figno)
    figno= handles.MHdata.figno;
    zoom_on = get(hObject,'value');
    if zoom_on
        zoom(figno,'yon')
    else
        zoom(figno,'yoff')
    end
end
return


%=== POPUPMENU_FIGURE =====================================
function popupmenu_Figure_Callback(hObject, eventdata, handles)
handles.MHdata.figno=ReadPopup(hObject,1);
guidata(hObject,handles);
return

function popupmenu_Figure_CreateFcn(hObject, eventdata, handles)
popupmenu_Figure_Callback(hObject, eventdata, handles)
return

%=== RADIOBUTTON_PX =======================================
function radiobutton_p_Callback(hObject, eventdata, handles)
str= get(hObject,'tag');
n1 = sscanf(str,'radiobutton_p%d');
n2 = sscanf(str,'radiobutton_dp%d/dt');
val= get(hObject,'Value');

if not(isempty(n1))       % p-button pressed
    n  = n1;
    ref= 'pressure';
elseif not(isempty(n2))  % dp/dt-button pressed
    n  = n2;
    ref= 'dpdt';
else
    return
end
GraphOnOff(handles.MHdata.figno, ref, ref, n,val); % Turn selected graph on or off
              
return



%=== UTILITY FUNCTIONS. LH =================================
function s=ReadPopup(hobj,numeric)
if nargin<2, numeric=0; end
str = get(hobj,'String');             % returns popupmenu contents as cell array
val = get(hobj,'Value');
s   = str{val};
if numeric
    n1=regexp(s,'[.\d]');  % Remove all but numbers and decimal point    
    s=str2num(s(n1));
end
return

function ScaleImage(ax,im,iminfo,adapt)
set(ax, 'Units', 'pixels');    % Display image in 'axis1'
axes(ax);
image(im)

impos=get(ax,'position');         % Scale axes for image

if adapt
    impos(3)= iminfo.Width*impos(4)/iminfo.Height;  % Adapt image to axis
else
    impos(2)= impos(2)+impos(4)-iminfo.Height;
    impos(3)= iminfo.Width;                       % Adapt axes to image
    impos(4)= iminfo.Height;
end

set(ax, ...
    'Visible', 'off', ...
    'Position', impos);

return











