function h=PlotWaveform(trace,method,varargin)
% function PlotWaveform(trace,symbol,method)
%
% Plot waveform trace
%    trace.t0
%    trace.dt
%    trace.y

% Lars Hoff, HVE, May 2005
%          Delay added, Nov 2006
[N M]= size(trace.y);

if isfield(trace,'delay')
    delay= trace.delay;
else
    delay= 0;
end

t= trace.t0-delay+[0:N-1]*trace.dt;

h=feval(method, t, trace.y, varargin{:} );

end
    