%%% bestem_beatdetektor = 1 -> bruker FinnQRboelgen
%%% bestem_beatdetektor = 0 -> bruker finnBeatVHATrykk


function [sample,wfm,par, data] = Posisjonsplot(measdata, bestem_beatdetektor)
global beatStart
[sample,wfm,par]= LoadDatafile(measdata);
sample=sample(1); 
fs = wfm.samplerate;
%%%Skalere og fikse alt slikt tull

%--- Limit calculation interval --
wfmr= wfm;
wfmr.timelimits= FindInterval(measdata.interval,wfm.samplerate);
wfmr.trace = wfm.trace(:,wfmr.timelimits.n0+(0:wfmr.timelimits.Nn-1));

scaled= Trace2Acc(sample,wfmr);
scaled.ECG.delay= measdata.ECGdelay*1e-3;  % ECG-delay input is in ms

% Trykkdataen ligger feil i ap112, ap114 og ap116
if(strcmp(measdata.AP,'AP110') == 1 || strcmp(measdata.AP,'AP111') == 1 )
    trykk.lv = scaled.p.y(:,1);% Venstre ventrikkeltrykk
    trykk.abp = scaled.p.y(:,2); %Aorta blodtrykk
else
    trykk.lv = scaled.p.y(:,2);% Venstre ventrikkeltrykk
    trykk.abp = scaled.p.y(:,1); %Aorta blodtrykk
end

% Feil fortegn p noen av retningene, blir fikset her 
if(strcmp(measdata.AP,'AP110') == 1)
    scaled.a.y(:,5) = -1* scaled.a.y(:,5);
else
    scaled.a.y(:,5) = -1* scaled.a.y(:,5);
    scaled.a.y(:,6) = -1* scaled.a.y(:,6);
end


%ecg = scaled.ECG.y(:,1);

skalertWFM.trace(2,:) = scaled.ECG.y(:,2);
skalertWFM.samplerate = fs;

if(bestem_beatdetektor == 1)
    RxMatrix = FinnQRboelgen(skalertWFM,0);
    beatStart = RxMatrix(1,:);
    beatStopp = RxMatrix(2,:);
    
    % flytter start/stopp 0,3 sec sampler for  unng  begynne p R-toppen
    beatStart = beatStart - round(0.15 * wfm.samplerate);
    beatStopp = beatStopp - round(0.15 * wfm.samplerate);
elseif(bestem_beatdetektor == 0)
    vil_du_ha_plassering = 1;
    beatStart = finnBeatVHATrykk(trykk.lv, fs, vil_du_ha_plassering);
    beatStopp = circshift( beatStart , [1 -1]); beatStopp(end) =  beatStopp(end - 1);
end

antallHjerteslaglag = length(beatStart);

% Integrere LAD
posisjon.x = MHintegrate(scaled.a.y(:,4),fs, 1, 2);
posisjon.y = MHintegrate(scaled.a.y(:,5),fs, 1, 2);
posisjon.z = MHintegrate(scaled.a.y(:,6),fs, 1, 2);

% trykk.lv = scaled.p.y(:,1);
% trykk.abp = scaled.p.y(:,2);

[ivc ivr] = trekkUtIvrc(trykk, beatStart,beatStopp, wfm.samplerate);
%vinkelen = vinkel(posisjon, ivr, ivc );

data.ivrc.ivr = ivr;
data.ivrc.ivc = ivc;
data.trykk = trykk;
data.posisjon = posisjon;
data.akselerasjon.x = scaled.a.y(:,4);
data.akselerasjon.y = scaled.a.y(:,5);
data.akselerasjon.z = scaled.a.y(:,6);
data.akselerasjon.t0 = scaled.a.t0;
data.scaled = scaled;
data.beatStart = beatStart;
data.beatStopp = beatStopp;
data.fs = wfm.samplerate;
