function y= projection(s,dir)
% function y= projection(s,dir)
%
% Project 2D or 3D vector 's' along axis 'direction'
%   s  : Input 2D/3D vector
%   dir: Direction to project 's'
%        Specified as [x y (z)]
%               

% Lars Hoff, HVE, Jan 2007

[N M]= size(s);
Md   = length(dir);

dir = reshape(dir, [1 M]);  % Accept 'dir' as both row and column format 
n   = dir/sqrt(sum(dir.^2));
y   = zeros(N,1);
for k=1:N
    y(k,1)= sum(s(k,:).*n);
end

return