%function measdata = kjorProgram()
% 
% Calculate and plot results of ivr/ivc extraction 

% Kristian degaard, NTNU, 2007

% Based on file PlotMicroheart.m by Lars Hoff, HVE, Nov 2004
%
clear all
measdata.AP        = 'AP110';   % Experiment 'AP116'
measdata.recording = 4;         % Recording no. X
measdata.systemid  = 'B';       % System 'B'
measdata.respfilter= -1;        % Automatic respiration filter
measdata.ECGdelay  = 21.5;      % Delay in Siemens patient monitor
measdata.interval  = [2035+10 2400-10]; % Interval to plot [s]

measdata.Ncurves   = 3;         % Plot 3 curves 

mtypes= {'Acceleration', 'Velocity', 'Position'};
maxes = {'x', 'y', 'z'};
m = 3; %Posision
%for m=1:3
    measdata.figno = m;
    for k=1:measdata.Ncurves    
        measdata.curve(k).type   = mtypes{m};   % Cycle over types
        measdata.curve(k).sensor = 'B';         % Sensor 'B'  in all plots
        measdata.curve(k).ax     = maxes{k};    % Cycle over axes
        measdata.curve(k).invert = 1;           % Invert 'on'
    end
     [sample,wfm,par,data] = Posisjonsplot(measdata, 0);
   
%end
