function handle=stackplots(N)
% function handle=stackplots(N)
%
% Create a multi-graph figure with stacked subplots

% Lars Hoff, HVE, Dec 2005

rh= 0.98;
dx= 0.10;
dy= 0.10;
w = 0.85;
h = (1-2*dy)/N;
y = dy+[N-1:-1:0]*h;

for k=N:-1:1
    handle(k)=subplot(N,1,k);
    set(gca,'position', [dx y(k) w h*rh ]); 
    set(gca,'ActivePositionProperty', 'position')
    set(gca,'Box', 'on')
    set(gca,'XTickLabel', []) 
    grid on
end
set(handle(N), 'XTickLabelMode', 'Auto')

return