%%% Beregner vinkelen mellom 2 eller 3 plan. Dersom man nsker to-plan,
%%% setter man to_plan = 1. Vil man ha 3-plan s setter man to_plan = 0.
%%% Data bestr av all dataen som er lagret fra kjorProgram.m
%%% Vinkel = en matrise som inneholder de forskjellige vinkelen i de
%%% forskjellige planene.

function vinkel = beregnVinkel(data,to_plan)
clear vinkel filtrerIvr filtrerIvc
% tidsintervall = measdata.interval;

% setter navn p en del parametere som blir brukt fra data
posX = data.posisjon.x';
posY = data.posisjon.y';
posZ = data.posisjon.z';
ivc = data.ivrc.ivc;
ivr = data.ivrc.ivr;
beatStart = data.beatStart;

% Leser inn referanse ivc og ivr fra friskt-omrde
ref = load('referanse_AP114.mat');
ivcRefx = ref.posXivc;
ivcRefy = ref.posYivc;
ivcRefz = ref.posZivc;
ivrRefx = ref.posXivr;
ivrRefy = ref.posYivr;
ivrRefz = ref.posZivr;


if ( to_plan == 1 )

    %%% Beregner vinkelen mellom ivr-start og de etterflgende samplevinklene
    for j = 1:length(ivr)
        % Nullstiller en del paramaterer
        clear ivcX ivcY ivcZ ivrX ivrY ivrZ midl

        % Setter parametere som blir brukt gjennom hele lkka
        ivcX = posX(ivc(j,1):ivc(j,2));
        ivcY = posY(ivc(j,1):ivc(j,2));
        ivcZ = posZ(ivc(j,1):ivc(j,2));
        ivrX = posX(ivr(j,1):ivr(j,2));
        ivrY = posY(ivr(j,1):ivr(j,2));
        ivrZ = posZ(ivr(j,1):ivr(j,2));
        midl = zeros(1,ivc(j,2)-ivc(j,1)+1);

        %%% Beregne vinklene mellom alle punktene i en ivc-periode
        for i = 1:(ivc(j,2)-ivc(j,1))
            xvektor = ivcX(i+1) - ivcRefx;%posX(beatStart(j));%ivcX(1);%
            yvektor = ivcY(i+1) - ivcRefy;%(ivc(1,1));%posY(beatStart(j));%ivcY(1);
            midl(i) = atan(yvektor / xvektor) *360/(2*pi);
        end
        % Lagrer den strste vinkel-forandring ved xy-retning i ivc
        vinkel.ivc.xy(j,1) = max(abs(midl));

        for i = 1:(ivc(j,2)-ivc(j,1))
            xvektor = ivcX(i+1) - ivcRefx;%posX(ivc(1,1));%posX(beatStart(j));%ivcX(1);
            zvektor = ivcZ(i+1) - ivcRefz;%posZ(ivc(1,1));%posZ(beatStart(j));%ivcZ(1);
            midl(i) = atan(zvektor / xvektor) *360/(2*pi);
        end
        % Lagrer den strste vinkel-forandring ved xz-retning i ivc
        vinkel.ivc.xz(j,1) = max(abs(midl));

        for i = 1:(ivc(j,2)-ivc(j,1))
            yvektor = ivcY(i+1) - ivcRefy;%posY(ivc(1,1));%posY(beatStart(j));%ivcY(1);
            zvektor = ivcZ(i+1) - ivcRefz;%posZ(ivc(1,1));%posZ(beatStart(j));%ivcZ(1);
            midl(i) = atan(zvektor / yvektor) *360/(2*pi);
        end
        % Lagrer den strste vinkel-forandring ved yz-retning i ivc
        [vinkel.ivc.yz(j,1)] = max(abs(midl));
%         [verdi plass] = max(abs(midl));
%         vinkel.ivc.yz(j,1) = midl(plass);
        
        clear midl
        midl = zeros(1,ivr(j,2)-ivr(j,1));

        %%% Beregne vinklene mellom alle punktene i en ivr-periode
        for i = 1:( ivr(j,2)-ivr(j,1) )
            xvektor = ivrX(i+1) - ivrRefx;%posX(ivr(1,1));%posX(beatStart(j));%ivrX(1);
            yvektor = ivrY(i+1) - ivrRefy;%posY(ivr(1,1));%posY(beatStart(j));%posY(beatStart(j));%ivrY(1);
            midl(i) = atan( yvektor / xvektor ) *360/(2*pi);
        end
        % Lagrer den strste vinkel-forandring i xy-retning i ivr-periode
        vinkel.ivr.xy(j,1) = max(abs(midl));
%         [verdi plass] = max(abs(midl));
%         vinkel.ivr.xy(j,1) = midl(plass);

        for i = 1:( ivr(j,2)-ivr(j,1) )
            xvektor = ivrX(i+1) - ivrRefx;%posX(ivr(1,1));%posX(beatStart(j));%ivrX(1);
            zvektor = ivrZ(i+1) - ivrRefz;%posZ(ivr(1,1));%posZ(beatStart(j));%ivrZ(1);
            midl(i) = atan( zvektor / xvektor ) *360/(2*pi);
        end
        % Lagrer den strste vinkel-forandring i xz-retning i ivr-periode
%         vinkel.ivr.xz(j,1) = max(abs(midl));
        [verdi plass] = max(abs(midl));
        vinkel.ivr.xz(j,1) = midl(plass);

        for i = 1:( ivr(j,2)-ivr(j,1) )
            yvektor = ivrY(i+1) - ivrRefy;%posY(ivr(1,1));%posY(beatStart(j));%ivrY(1);
            zvektor = ivrZ(i+1) - ivrRefz;%posZ(ivr(1,1));%posZ(beatStart(j));%ivrZ(1);
            midl(i) = atan( zvektor / yvektor ) *360/(2*pi);
        end
        % Lagrer den strste vinkel-forandring i yz-retning i ivr-periode
        vinkel.ivr.yz(j,1) = max(abs(midl));
%         [verdi plass] = max(abs(midl));
%         vinkel.ivr.yz(j,1) = midl(plass);
        clear midl
    end
else
    
    
   for i = 1:length(ivr)
       clear ivcX ivcY ivcZ ivrX ivrY ivrZ midl
       % Setter parametere som blir brukt gjennom hele lkka
        ivcX = posX(ivc(i,1):ivc(i,2)+100);
        ivcY = posY(ivc(i,1):ivc(i,2)+100);
        ivcZ = posZ(ivc(i,1):ivc(i,2)+100);
        ivrX = posX(ivr(i,1):ivr(i,2)+100);
        ivrY = posY(ivr(i,1):ivr(i,2)+100);
        ivrZ = posZ(ivr(i,1):ivr(i,2)+100);
        midl = zeros(1,ivc(i,2) + 100 -ivc(i,1));
  
       for j= 1:(ivc(i,2)-ivc(i,1))
           x = ivcX(j+1)- ivcRefx;%ivcX(1);%posX(ivc(1,1));%%posX(beatStart(i));%ivcX(1);%posX(ivc(1,1));%
           y = ivcY(j+1)- ivcRefy;%ivcY(1);%posY(ivc(1,1));%%posY(beatStart(i));%ivcY(1);%posY(ivc(1,1));
           r = sqrt(x.^2 + y.^2);
           z = ivcZ(j+1)- ivcRefz;%ivcZ(1);%posZ(ivc(1,1));%%posZ(beatStart(i));%ivcZ(1);%posZ(ivc(1,1));
           midl(j) = atan(z/r)*360/(2*pi);
       end
       vinkel.ivc(i,1) = max(abs(midl));
       
       clear midl
       midl = zeros(1,ivr(i,2)-ivr(i,1));
       
       for j= 1:(ivr(i,2)-ivr(i,1))
           x = ivrX(j+1)- posX(ivr(1,1));%ivrRefx;%posX(beatStart(i));%ivrX(1);%posX(beatStart(i));%posX(ivr(1,1));
           y = ivrY(j+1)- posY(ivr(1,1));%ivrRefy;%posY(beatStart(i));%ivrY(1);%posY(beatStart(i));%posY(ivr(1,1));
           r = sqrt(x.^2 + y.^2);
           z = ivrZ(j+1)- posZ(ivr(1,1));%ivrRefz;%posZ(beatStart(i));%ivrZ(1);%posZ(beatStart(i));%posZ(ivr(1,1));
           midl(j) = atan(z/r)*360/(2*pi);
       end
       
       vinkel.ivr(i,1) = max(abs(midl));

   end
end


%Kjrer dataen gjennom et filter for  motvirke sty
if(to_plan == 1)
    filtrerIvc = vinkel.ivc.xy;
    midler = [];
    for i =1:length(filtrerIvc) - 10
            midler(i) = sum( filtrerIvc(i) + filtrerIvc(i+1) + filtrerIvc(i+2) + filtrerIvc(i+3) + filtrerIvc(i+4) + filtrerIvc(i+5) + filtrerIvc(i+6) + filtrerIvc(i+7) + filtrerIvc(i+8) + filtrerIvc(i+9) ) / 10;  %+ filtrer(i+10) + filtrer(i+11)) 
    end
    vinkel.ivc.xy = midler;
    
    filtrerIvc = vinkel.ivc.xz;
    for i =1:length(filtrerIvc) - 10
            midler(i) = sum( filtrerIvc(i) + filtrerIvc(i+1) + filtrerIvc(i+2) + filtrerIvc(i+3) + filtrerIvc(i+4) + filtrerIvc(i+5) + filtrerIvc(i+6) + filtrerIvc(i+7) + filtrerIvc(i+8) + filtrerIvc(i+9) ) / 10;  %+ filtrer(i+10) + filtrer(i+11)) 
    end
    vinkel.ivc.xz = midler;
    
    filtrerIvc = vinkel.ivc.yz;
    for i =1:length(filtrerIvc) - 10
            midler(i) = sum( filtrerIvc(i) + filtrerIvc(i+1) + filtrerIvc(i+2) + filtrerIvc(i+3) + filtrerIvc(i+4) + filtrerIvc(i+5) + filtrerIvc(i+6) + filtrerIvc(i+7) + filtrerIvc(i+8) + filtrerIvc(i+9) ) / 10;  %+ filtrer(i+10) + filtrer(i+11)) 
    end
    vinkel.ivc.yz = midler;

    filtrerIvr = vinkel.ivr.xy;
    for i =1:length(filtrerIvr) - 10
            midler(i) = sum( filtrerIvr(i) + filtrerIvr(i+1) + filtrerIvr(i+2) + filtrerIvr(i+3) + filtrerIvr(i+4) + filtrerIvr(i+5) + filtrerIvr(i+6) + filtrerIvr(i+7) + filtrerIvr(i+8) + filtrerIvr(i+9) ) / 10;  %+ filtrer(i+10) + filtrer(i+11)) 
    end
    vinkel.ivr.xy = midler;
    
    filtrerIvr = vinkel.ivr.xz;
    for i =1:length(filtrerIvr) - 10
            midler(i) = sum( filtrerIvr(i) + filtrerIvr(i+1) + filtrerIvr(i+2) + filtrerIvr(i+3) + filtrerIvr(i+4) + filtrerIvr(i+5) + filtrerIvr(i+6) + filtrerIvr(i+7) + filtrerIvr(i+8) + filtrerIvr(i+9) ) / 10;  %+ filtrer(i+10) + filtrer(i+11)) 
    end
    vinkel.ivr.xz = midler;
    
    filtrerIvr = vinkel.ivr.yz;
    for i =1:length(filtrerIvr) - 10
            midler(i) = sum( filtrerIvr(i) + filtrerIvr(i+1) + filtrerIvr(i+2) + filtrerIvr(i+3) + filtrerIvr(i+4) + filtrerIvr(i+5) + filtrerIvr(i+6) + filtrerIvr(i+7) + filtrerIvr(i+8) + filtrerIvr(i+9) ) / 10;  %+ filtrer(i+10) + filtrer(i+11)) 
    end
    vinkel.ivr.yz = midler;
else
    filtrerIvc = vinkel.ivc;
    midler = [];
    for i =1:length(filtrerIvc) - 10
            midler(i) = sum( filtrerIvc(i) + filtrerIvc(i+1) + filtrerIvc(i+2) + filtrerIvc(i+3) + filtrerIvc(i+4) + filtrerIvc(i+5) + filtrerIvc(i+6) + filtrerIvc(i+7) + filtrerIvc(i+8) + filtrerIvc(i+9) ) / 10;  %+ filtrer(i+10) + filtrer(i+11)) 
    end
    vinkel.ivc = midler;

    filtrerIvr = vinkel.ivr;
    for i =1:length(filtrerIvr) - 10
            midler(i) = sum( filtrerIvr(i) + filtrerIvr(i+1) + filtrerIvr(i+2) + filtrerIvr(i+3) + filtrerIvr(i+4) + filtrerIvr(i+5) + filtrerIvr(i+6) + filtrerIvr(i+7) + filtrerIvr(i+8) + filtrerIvr(i+9) ) / 10;  %+ filtrer(i+10) + filtrer(i+11)) 
    end
    vinkel.ivr = midler;
end


% plotter graf
% t = linspace(tidsintervall(1)-10,tidsintervall(2)+10,length(filtrerIvr));
% plot(t,filtrerIvc); grid minor; 
% hold on;
% plot(t,filtrerIvr,'r');
% xlabel('Tid [s]');
% ylabel('Vinkel i grader');
% 
% posXivc = posX(ivc(1,1));
% posYivc = posY(ivc(1,1));
% posZivc = posZ(ivc(1,1));
% posXivr = posX(ivr(1,1));
% posYivr = posY(ivr(1,1));
% posZivr = posZ(ivr(1,1));
% % 
% save 'referanse_AP116.mat' 'posXivc' 'posYivc' 'posZivc' 'posXivr' 'posYivr' 'posZivr'